/*
	RT Bench - Benchmarks various hash functions for Rainbow Tables
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef HASH_H
#define HASH_H

#include "common.h"

typedef void (*HASHFUNC)(vector4 *pw, vector4 *hash);

struct hashAlgorithm
{
	HASHFUNC func;
	uint32_t len, hashesPerCall, charaterEncoding, numPwBlocks, numExtraHashBlocks;
};

void allocatePwHash(vector4 **pw, vector4 **hash, vector4 **deleteMe, uint32_t vecSize, uint32_t numPwBlocks, uint32_t numHashBlocks);

#endif
