/*
	RT Bench - Benchmarks various hash functions for Rainbow Tables
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef HEX_H
#define HEX_H

#include "common.h"

extern const uint16_t CONST_BYTE_TO_HEX[256];

#define CONVERT_TO_HEX(in,out1,out2,vl,vh,const_0x0f,const_0x09,const_0x27,const_0x30) \
	vh = _mm_srli_epi32(in, 4); \
	vl = _mm_and_si128(in, const_0x0f); \
	vh = _mm_and_si128(vh, const_0x0f); \
	vl = _mm_add_epi32(_mm_add_epi32(vl, _mm_and_si128(_mm_cmpgt_epi8(vl, const_0x09), const_0x27)), const_0x30); \
	vh = _mm_add_epi32(_mm_add_epi32(vh, _mm_and_si128(_mm_cmpgt_epi8(vh, const_0x09), const_0x27)), const_0x30); \
	out2 = _mm_unpackhi_epi8(vh, vl); \
	vh = _mm_unpacklo_epi8(vh, vl); \
	*((__m128*)&(out1)) = _mm_shuffle_ps(*((__m128*)&(vh)), *((__m128*)&(out2)), 0x88); \
	*((__m128*)&(out2)) = _mm_shuffle_ps(*((__m128*)&(vh)), *((__m128*)&(out2)), 0xdd);

#endif
